<template>
  <q-page
    class="q-mt-lg q-gutter-md text-grey-9"
    style="max-width: 720px; margin-inline: auto"
  >
    <q-form @submit="handleSubmit">
      <q-input
        v-model="query"
        label="Enter a word"
        :rules="[(val) => (val && val.length > 0) || 'Please enter a word']"
        outlined
      >
        <template v-slot:append>
          <q-btn flat icon="search" @click="handleSubmit" />
        </template>
      </q-input>
    </q-form>
    <span v-if="error" class="text-body2">{{ error }}</span>
    <div v-if="result !== null">
      <div class="q-mb-md text-h2 text-weight-medium">{{ result.word }}</div>
      <Meanings :meanings="result.meanings" />
    </div>
  </q-page>
</template>

<script setup>
import { ref } from "vue";
import axios from "axios";
import Meanings from "../components/Meanings.vue";

const query = ref("");
const result = ref(null);
const error = ref(null);

const handleSubmit = async () => {
  if (query.value.length <= 0) return;

  try {
    const res = await axios.get(
      `https://api.dictionaryapi.dev/api/v2/entries/en/${query.value}`
    );

    const data = await res.data[0];

    result.value = {
      word: data.word,
      meanings: data.meanings,
    };

    error.value = null;
  } catch {
    error.value = "The word you are searching does not exists...";
    result.value = null;
  }
};
</script>
